/**
 * \file
 *
 * \brief PLLǗ
 *
 * 쌠 (c) 2010-2011 Atmel Corporation. s
 *
 * \asf_license_start
 *
 * ύX̗L܂͂Ȃſ2ǐ`ł̎gpƍĔzz͈ȉ̏ɍĂ
 * ΋܂B
 *
 * 1.  ނ̍Ĕzz͏̒쌠ʒmȀꗗAƈȉ̂fێ
 *	  Ȃ΂Ȃ܂B
 *
 * 2. 2i`ł̍Ĕzz͂̔zzŒ񋟂ꂽ⑼̑fނŁA̒쌠ʒmA
 *	  ̏ꗗAƈȉ̂fČȂ΂Ȃ܂B
 *
 * 3. Atmel̖̂͐ɏꂽ̎wȂɂ̿ĳh̑i
 *	  (ۏ)ɎgpłȂ܂B
 *
 * 4. ̿ĳAtmelϲ ۰אiƂ̊֌WłĕzĎgp邱Ƃ
 *	  ܂B
 *
 * ̿ĳ͂ǂȖI܂͈ÎIȕۏ؁Aܕ̐Ȃ"󂻂̂܂"
 * AtmelɂĒ񋟂AړÎ߂̎sꐫƓK̈ÖٓIȕۏ؂͖
 * mɕ܂BƂAtmel̂悤ȑQ̉\iꂽ
 * ƂĂA{gpłȂA܂͎gpȊOŔ(̑Aƒ
 * fA܂͗v̑Ɋւ鐧Ȃ̑Q܂)AځAԐځAKRA
 * RAʁA܂͕tċN@Ȃ鑹Qɑ΂ĂAtmelɐӔC
 * Ȃł傤B
 *
 * \asf_license_stop
 *
 */
#ifndef CLK_PLL_H_INCLUDED
#define CLK_PLL_H_INCLUDED

#include "parts.h"
#include "conf_clock.h"

#if SAM3S
# include "sam3s/pll.h"
#elif SAM3XA
# include "sam3x/pll.h"
#elif SAM3U
# include "sam3u/pll.h"
#elif SAM3N
# include "sam3n/pll.h"
#elif SAM4S
# include "sam4s/pll.h"
#elif (UC3A0 || UC3A1)
# include "uc3a0_a1/pll.h"
#elif UC3A3
# include "uc3a3_a4/pll.h"
#elif UC3B
# include "uc3b0_b1/pll.h"
#elif UC3C
# include "uc3c/pll.h"
#elif UC3D
# include "uc3d/pll.h"
#elif (UC3L0128 || UC3L0256 || UC3L3_L4)
# include "uc3l/pll.h"
#elif XMEGA
# include "xmega/pll.h"
#else
# error Unsupported chip type
#endif

/**
 * \ingroup clk_group
 * \defgroup pll_group PLLǗ
 *
 * ̌QߏPLĽ`ԐݒƋ/֎~Ɋ֘A֐ƒ`܂݂܂BPLL
 * ͓͐M(\em source)ACӂŌ`Ԑݒ\ȕ(\em divider)ɂ
 * Ďg𕪎ǍɌ`Ԑݒ\Ȓ{(\em multiplier)ɂĎg
 * {܂B
 *
 * ޲͓͕xA޲ł1ȊȎ̂ǂ̕
 * lw\ᔽɋA܂B̑޲͓͂Əo͂̐M̎g͈
 * ɗlXȐ܂B
 *
 * \par : ҰłPLL0\ݒ
 *
 * ȉ̗͏ňꗗɂꂽ`ԐݒقpĎw肳ꂽҰgp
 * POLL0`Ԑݒ肵ċ@܂B
 * \code
	pll_enable_config_defaults(0); \endcode
 *
 * `Ԑݒ肷ɂ́AҰpPLL0`ԐݒA邽߂ƁALш敝
 * (UC3A3LPLLCӑI)̂悤ȓL@\֎~߂ɁȀ菇gp
 * 邱Ƃł܂B
 * \code
	struct pll_config pllcfg;
	if (pll_is_locked(pll_id)) {
		return; // PLL͊ɑs
	}
	pll_enable_source(CONFIG_PLL0_SOURCE);
	pll_config_defaults(&pllcfg, 0);
	pll_config_set_option(&pllcfg, PLL_OPT_WBM_DISABLE);
	pll_enable(&pllcfg, 0);
	pll_wait_for_lock(0); \endcode
 *
 * Ō̊֐Ăяo߂ƁAPLL0͎弽 ۯƂĎgp鏀
 * ܂B
 *
 * \section pll_group_config `Ԑݒ
 *
 * ePLL͉p̌`Ԑݒ̧قňȉ̌`ԐݒقɂČ߂ꂽҰ
 * g܂B:
 *   - \b CONFIG_PLLn_SOURCE: PLL \a n̓͂ɐڑۯB
 *     #pll_source enumɂĒ`ꂽl1łȂ΂Ȃ܂B
 *   - \b CONFIG_PLLn_MUL: PLL \a n̊{(H)
 *   - \b CONFIG_PLLn_DIV: PLL \a n͕̊
 *
 * ̌`Ԑݒقpll_config_defaults()pll_get_default_rate()Ăяo
 * ̌ʂ߂܂B
 *
 * @{
 */

//! \name ߓLPLL
//@{
/**
 * \def PLL_MAX_STARTUP_CYCLES
 * \brief ᑬۯł̍őPLLn
 */
/**
 * \def NR_PLLS
 * \brief ߏPLL
 */

/**
 * \def PLL_MIN_HZ
 * \brief PLLłŏg
 */
/**
 * \def PLL_MAX_HZ
 * \brief PLLłőg
 */
/**
 * \def PLL_NR_OPTIONS
 * \brief PLLCӑIޯĐ
 */
//@}

/**
 * \enum pll_source
 * \brief PLLۯ
 */

//! \name PLL`Ԑݒ
//@{

/**
 * \struct pll_config
 * \brief PLL`Ԑݒʰ޳L\
 *
 * ̍\݂̂͌PLL`Ԑݒ\1ȏ޲Ll܂݂܂B̍\
 * ̂̓e͈ʓIɊՖɈقȂAgp҂PLL`ԐݒAPIʂȊOAǂ̗̈
 * ౸ׂł͂܂B
 */

/**
 * \fn void pll_config_init(struct pll_config *cfg,
 *              enum pll_source src, unsigned int div, unsigned int mul)
 * \brief WҰPLL`Ԑݒ
 *
 * \note ̊֐͂ꂪɂ߂Đ񂵂Ă΂ꂸAʏŒҰ߁Aײ
 * ݂Œ`邩܂Bײ݉ŁÂ悤ȏꍇAȂ躰ޗʂ炵
 * ܂B
 *
 * \param	cfg		ׂPLL`Ԑݒ
 * \param	src		PLLւ̓͂ƂĎgp锭U
 * \param	div		PLL͕
 * \param	mul		PLLH(A{)
 *
 * \return			\a src̎g(\a mul / \a div){PLL𑖂点`Ԑݒ
 */
/**
 * \def pll_config_defaults(cfg, pll_id)
 * \brief ҰpPLL`Ԑݒ
 *
 * ̊֐߂A\a cfgCONFIG_PLLx_SOURCE̎g(CONFIG_PLLx_MUL / 
 * CONFIG_PLLx_DIV){PLL𑖂点`Ԑݒ܂݂܂B
 *
 * \param	cfg		ׂPLL`Ԑݒ
 * \param	pll_id	PLLɑ΂Ċgp
 */
/**
 * \def pll_get_default_rate(pll_id)
 * \brief \a pll_idHzł̊葬x擾
 */
/**
 * \fn void pll_config_set_option(struct pll_config *cfg,
 *              unsigned int option)
 * \brief `Ԑݒ\a cfgPLLCӑIޯ\a optionݒ
 *
 * \param	cfg		ύXׂPLL`Ԑݒ
 * \param	option	ݒ肷PLLCӑIޯ
 */
/**
 * \fn void pll_config_clear_option(struct pll_config *cfg,
 *              unsigned int option)
 * \brief `Ԑݒ\a cfgPLLCӑIޯ\a option
 *
 * \param	cfg		ύXׂPLL`Ԑݒ
 * \param	option	PLLCӑIޯ
 */
/**
 * \fn void pll_config_read(struct pll_config *cfg, unsigned int pll_id)
 * \brief \a pll_iď݊Ȍ`Ԑݒǂݍ
 *
 * \param	cfg		݊Ȍ`Ԑݒi[邽߂̌`Ԑݒ
 * \param	pll_id	PLLID
 */
/**
 * \fn void pll_config_write(const struct pll_config *cfg,
 *              unsigned int pll_id)
 * \brief \a pll_iď`Ԑݒ\a cfg
 *
 * \param	cfg		ɂPLL`Ԑݒ\`Ԑݒ
 * \param	pll_id	XVPLLID
 */

//@}

//! \name PLLʰ޳Ƃ̑ݍp
//@{
/**
 * \fn void pll_enable(const struct pll_config *cfg,
 *              unsigned int pll_id)
 * \brief `Ԑݒ\a cfgɂPLL \a pll_id
 *
 * \param	cfg		ɂPLL`Ԑݒ
 * \param	pll_id	PLLID
 */
/**
 * \fn void pll_disable(unsigned int pll_id)
 * \brief \a pll_idɂĎʂPLL֎~
 *
 * ̊֐ĂяoA\a pll_idɂĎʂꂽPLL֎~܂Bɂ
 * ʰ޳Ŋi[ꂽPLL`Ԑݒ肪eyڂ邩ꂸÂɌĂяo
 * œ`Ԑݒ̕]ޏꍇAPLL֎~Opll_config_read()A
 * PLLɍŌɏꂽ`ԐݒL邩̂ǂ炩sׂłB
 *
 * \param	pll_id	֎~PLLID
 */
/**
 * \fn bool pll_is_locked(unsigned int pll_id)
 * \brief PLL{Ă邩ۂ𔻒f
 *
 * \param	pll_id	ׂPLLID
 *
 * \retval	true	PLL͎{AۯƂĎgpĂ܂B
 * \retval	false	PLL͖{ĂȂA܂͋ꂢ܂B
 */
/**
 * \fn void pll_enable_source(enum pll_source src)
 * \brief PLL̋
 * ɑsłȂ΁A܂B
 *
 * \param	src		PLLID
 */
/**
 * \fn void pll_enable_config_defaults(unsigned int pll_id)
 * \brief `ԐݒPLL
 * PLLɎ{ĂȂꍇPLL܂B
 *
 * \param	pll_id	PLLID
 */

/**
 * \brief PLL \a pll_id{ɂȂ̂ҋ@
 *
 * \todo iv҂Ƽђ~邽߂ɐԂgpĂB
 *
 * \param	pll_id	ҋ@PLLID
 *
 * \retval	STATUS_OK		PLL͍{Ă܂B
 * \retval	ERR_TIMEOUT		{ɂȂPLLҋ@Ԓ
 */
static inline int pll_wait_for_lock(unsigned int pll_id)
{
	Assert(pll_id < NR_PLLS);

	while (!pll_is_locked(pll_id)) {
		/* Ȃ */
	}

	return 0;
}

//@}
//! @}

#endif /* CLK_PLL_H_INCLUDED */
