/**
 * \file
 *
 * \brief  ۯǗ
 *
 * 쌠 (c) 2010-2012 Atmel Corporation. s
 *
 * \asf_license_start
 *
 * ύX̗L܂͂Ȃſ2ǐ`ł̎gpƍĔzz͈ȉ̏ɍĂ
 * ΋܂B
 *
 * 1.  ނ̍Ĕzz͏̒쌠ʒmȀꗗAƈȉ̂fێ
 *	  Ȃ΂Ȃ܂B
 *
 * 2. 2i`ł̍Ĕzz͂̔zzŒ񋟂ꂽ⑼̑fނŁA̒쌠ʒmA
 *	  ̏ꗗAƈȉ̂fČȂ΂Ȃ܂B
 *
 * 3. Atmel̖̂͐ɏꂽ̎wȂɂ̿ĳh̑i
 *	  (ۏ)ɎgpłȂ܂B
 *
 * 4. ̿ĳAtmelϲ ۰אiƂ̊֌WłĕzĎgp邱Ƃ
 *	  ܂B
 *
 * ̿ĳ͂ǂȖI܂͈ÎIȕۏ؁Aܕ̐Ȃ"󂻂̂܂"
 * AtmelɂĒ񋟂AړÎ߂̎sꐫƓK̈ÖٓIȕۏ؂͖
 * mɕ܂BƂAtmel̂悤ȑQ̉\iꂽ
 * ƂĂA{gpłȂA܂͎gpȊOŔ(̑Aƒ
 * fA܂͗v̑Ɋւ鐧Ȃ̑Q܂)AځAԐځAKRA
 * RAʁA܂͕tċN@Ȃ鑹Qɑ΂ĂAtmelɐӔC
 * Ȃł傤B
 *
 * \asf_license_stop
 *
 */
#ifndef SYSCLK_H_INCLUDED
#define SYSCLK_H_INCLUDED

#include "parts.h"
#include "conf_clock.h"

#if SAM3S
# include "sam3s/sysclk.h"
#elif SAM3U
# include "sam3u/sysclk.h"
#elif SAM3N
# include "sam3n/sysclk.h"
#elif SAM3XA
# include "sam3x/sysclk.h"
#elif SAM4S
# include "sam4s/sysclk.h"
#elif (UC3A0 || UC3A1)
# include "uc3a0_a1/sysclk.h"
#elif UC3A3
# include "uc3a3_a4/sysclk.h"
#elif UC3B
# include "uc3b0_b1/sysclk.h"
#elif UC3C
# include "uc3c/sysclk.h"
#elif UC3D
# include "uc3d/sysclk.h"
#elif UC3L
# include "uc3l/sysclk.h"
#elif XMEGA
# include "xmega/sysclk.h"
#else
# error Unsupported chip type
#endif

/**
 * \defgroup clk_group ۯǗ
 */

/**
 * \ingroup clk_group
 * \defgroup sysclk_group  ۯǗ
 *
 * \ref sysclk_quickstartB
 *
 * <em>sysclk</em> API<em> ۯ</em>ƂꂩhSĂ̸ۯԗ
 * ܂B ۯ͑SĂ<em>ۯ</em>AACPU޽/Ӌ@\̸ۯ
 * ɂߓۯłB ۯ͈ʓIɸؽقRC̔U킾łȂPLL
 * ܂ݓlXȋ1琶܂B ۯhۯ́A
 * UPLL瓮<em>ʸۯ</em>Ƃ͑ΏƓIɁA炪݂ɑ΂
 * ďɓē߁AXA<em>ۯ</em>ƂĂm܂B
 *
 * wǂ̉pͼ ۯƂ̋(UAPLLDFLL)Ɋ֘ASĂ
 * Ă̂܂܂ɂ̂ɒPsysclk_init()ĂԂׂłB荂xȉpƊ
 * Lײނ͸ۯ тǉ̻޽KvꂸA̓̂͊
 * L܂B
 *
 * \section sysclk_group_platform Ոˑ
 *
 * sysclk API͕I߂܂͊ՓLłBSĂ̊ՂwǓ@\񋟂
 * ŁAe޽^Ƹۯ\ǂ邩ɂĂ̕ώ킪
 * ܂B
 *
 * ȉ̊֐͓ҰƋ@\őSĂ̊Ղŗp\łB̊֐͉
 * ̉pAײށA޽ɂĎRɌĂ΂꓾܂B:
 *   - sysclk_init()
 *   - sysclk_set_source()
 *   - sysclk_get_main_hz()
 *   - sysclk_get_cpu_hz()
 *   - sysclk_get_peripheral_bus_hz()
 *
 * ȉ̊֐͑SĂ̊Ղŗp\łA֐[(AҰ)Ɠŕω
 * 邩܂B̊֐͈ʓIײނ̊ՓLƉӐ}
 * ȂpɂČĂ΂܂B:
 *   - sysclk_enable_peripheral_clock()
 *   - sysclk_disable_peripheral_clock()
 *   - sysclk_enable_module()
 *   - sysclk_disable_module()
 *   - sysclk_module_is_enabled()
 *   - sysclk_set_prescalers()
 *
 * ̑SĂ̊֐͊ՓLƌ􂳂ׂłBӋ@\ɑ΂ۯ̋
 * /֎~łȂA̸ۯ̑x߂邱ƂA̎Ӌ@\pײނ
 * Ē񋟂֐ĂԂƂɂčsׂłB
 *
 * @{
 */

//! \name  ۯ
//@{
/**
 * \fn void sysclk_init(void)
 * \brief ۯ я
 *
 * ̊֐ͼ ۯƂ̋܂B͈ȉ܂܂:
 *   - Wɑ΂ďdvȂǂ̸ۯ(Ⴆ΁A ۯ)ASĂ̓
 *     ۯՕ
 *   - p̌`Ԑݒ̧قɂĎw肳悤ɼ ۯOu\ݒ
 *   - p̌`Ԑݒ̧قɂĎw肳ۯ(U܂PLL)Ĉ
 *     ɂȂ܂őҋ@
 *   - 弽 ۯp̌`Ԑݒ̧قɂĎw肳ۯɐݒ
 *
 * dvłȂSĂ̎Ӌ@\ۯ͏ɋ֎~AWɕKvƂǂ̸ۯ
 * ċ͎̂Ӌ@\ײނ̐ӔCłB
 */
//@}

//! @}

#endif /* SYSCLK_H_INCLUDED */
