/**
 * \file
 *
 * \brief رٓǗ
 *
 * 쌠 (c) 2010 - 2012 Atmel Corporation. s.
 *
 * \asf_license_start
 *
 * ύX̗L܂͂Ȃſ2ǐ`ł̎gpƍĔzz͈ȉ̏ɍĂ
 * ΋܂B
 *
 * 1.  ނ̍Ĕzz͏̒쌠ʒmȀꗗAƈȉ̂fێ
 *	  Ȃ΂Ȃ܂B
 *
 * 2. 2i`ł̍Ĕzz͂̔zzŒ񋟂ꂽ⑼̑fނŁA̒쌠ʒmA
 *	  ̏ꗗAƈȉ̂fČȂ΂Ȃ܂B
 *
 * 3. Atmel̖̂͐ɏꂽ̎wȂɂ̿ĳh̑i
 *	  (ۏ)ɎgpłȂ܂B
 *
 * 4. ̿ĳAtmelϲ ۰אiƂ̊֌WłĕzĎgp邱Ƃ
 *	  ܂B
 *
 * ̿ĳ͂ǂȖI܂͈ÎIȕۏ؁Aܕ̐Ȃ"󂻂̂܂"
 * AtmelɂĒ񋟂AړÎ߂̎sꐫƓK̈ÖٓIȕۏ؂͖
 * mɕ܂BƂAtmel̂悤ȑQ̉\iꂽ
 * ƂĂA{gpłȂA܂͎gpȊOŔ(̑Aƒ
 * fA܂͗v̑Ɋւ鐧Ȃ̑Q܂)AځAԐځAKRA
 * RAʁA܂͕tċN@Ȃ鑹Qɑ΂ĂAtmelɐӔC
 * Ȃł傤B
 *
 * \asf_license_stop
 *
 */
#ifndef SERIAL_H_INCLUDED
#define SERIAL_H_INCLUDED

#include <parts.h>
#include "status_codes.h"

/**
 * \typedef usart_if
 *
 * ̌^͎gp{\ɑ΂USARTPʕQƂ邽߂ɓƗĎgp
 * Ƃł܂B{\ɑ΂Đ^`AAXMEGAɑ΂USART_t*
 * UC3ɑ΂avr32_usart_t*QƂ܂B
 */

#if XMEGA
# include "xmega_usart/usart_serial.h"
#elif (defined(__GNUC__) && defined(__AVR32__)) || (defined(__ICCAVR32__) || defined(__AAVR32__))
# include "uc3_usart/usart_serial.h"
#elif (defined(__GNUC__) || (defined(__ICCARM__)))
# include "sam_uart/uart_serial.h"
#else
# error Unsupported chip type
#endif

/**
 *
 * \defgroup serial_group ر ̪(ر)
 *
 * \ref serial_quickstartB
 *
 * ͼر ̪p̋APIłBt@\͓Pʕ̎ŗp\
 * B
 *
 * \section serial_group_platform Ոˑ
 *
 * رAPI͕I߂LłBSĂ̊ՂwǓ@\񋟂
 * ŁAe޽^Ƹۯ\ǂ邩ɂĂ̕ώ킪܂B
 *
 * ȉ̊֐͑SĂ̊Ղŗp\łA֐[(AҰ)Ɠł̕ω
 * L蓾܂B̊֐͈ʓIײނ̊ՓLƉӐ}Ȃ
 * pɂČĂ΂܂B:
 *   - usart_serial_init()
 *   - usart_serial_putchar()
 *   - usart_serial_getchar()
 *   - usart_serial_write_packet()
 *   - usart_serial_read_packet()
 *
 *
 * @{
 */
 
//! @}

/**
 * \page serial_quickstart ر ̪ ޽pJn̎
 *
 * ͎gpʂ̑Iżرق`Ԑݒ肵Ďg@̒iKIȎwł
 * \ref serial_group "ر ̪Pʕ"pJn̎łB
 *
 * gpʂ͂̺ޒfЂ܂݂܂B̒iKł̺ޒfЂ͓Ǝ
 * ɕʂ邱ƂłAŎg̒iḰAႦ΁A剞p֐ɕʂ邱
 * Ƃł܂B
 *
 * \section serial_use_cases رَgp
 * - \ref serial_basic_use_case
 * - \subpage serial_use_case_1
 *
 * \section serial_basic_use_case {IȎgp - M
 * ̎gpʂłͼرْPʕȉ̗lɌ`Ԑݒ肳܂B:
 * - USARTD0gp
 * - ްڰ : 9600
 * -  : 8ޯ
 * - è : ֎~
 * - ~ޯ : 1
 * - RS232
 *
 * ̎gpʂ͌`Ԑݒ肵USARTŎM҂Ă̕𓯂USARTɑ
 * Ԃ܂B
 *
 * \section serial_basic_use_case_setup iK
 *
 * \subsection serial_basic_use_case_setup_prereq OKv
 * -# \ref sysclk_group " ۯǗ(sysclk)"
 *
 * \subsection serial_basic_use_case_setup_code ޗ
 * ȉ̌`ԐݒۼުĂɒǉȂȂ܂(ʓIconf_serial.ḩ
 * ɂłA剞p̧قɒǉ邱Ƃł܂)B
 * \code
 *    #define USART_SERIAL                     &USARTD0
 *    #define USART_SERIAL_BAUDRATE            9600
 *    #define USART_SERIAL_CHAR_LENGTH         USART_CHSIZE_8BIT_gc
 *    #define USART_SERIAL_PARITY              USART_PMODE_DISABLED_gc
 *    #define USART_SERIAL_STOP_BIT            false
 * \endcode
 *
 * M޲ėpϐǉȂ΂Ȃ܂B:
 * \code uint8_t received_byte; \endcode
 *
 * pɒǉȂ΂Ȃ܂B:
 * \code
 *    sysclk_init();
 *
 *    static usart_serial_options_t usart_options = {
 *       .baudrate = USART_SERIAL_BAUDRATE,
 *       .charlength = USART_SERIAL_CHAR_LENGTH,
 *       .paritytype = USART_SERIAL_PARITY,
 *       .stopbits = USART_SERIAL_STOP_BIT
 *    };
 *
 *    usart_serial_init(USART_SERIAL, &usart_options);
 * \endcode
 *
 * \subsection serial_basic_use_case_setup_flow Ƃ̗
 * -#  ۯ:
 *   - \code sysclk_init(); \endcode
 * -# رUSARTCӑI\̍쐬:
 *   - \code
 *        static usart_serial_options_t usart_options = {
 *           .baudrate = USART_SERIAL_BAUDRATE,
 *           .charlength = USART_SERIAL_CHAR_LENGTH,
 *           .paritytype = USART_SERIAL_PARITY,
 *           .stopbits = USART_SERIAL_STOP_BIT
 *        };
 *     \endcode
 * -# ر ޽:
 *   - \code usart_serial_init(USART_SERIAL, &usart_options);\endcode
 *
 * \section serial_basic_use_case_usage giK
 *
 * \subsection serial_basic_use_case_usage_code ޗ
 * pÇقɒǉ:
 * \code
 *    usart_serial_getchar(USART_SERIAL, &received_byte);
 *    usart_serial_putchar(USART_SERIAL, received_byte);
 * \endcode
 *
 * \subsection serial_basic_use_case_usage_flow Ƃ̗
 * -# ̎Mҋ@:
 *   - \code usart_serial_getchar(USART_SERIAL, &received_byte); \endcode
 * -# Ԃ:
 *   - \code usart_serial_putchar(USART_SERIAL, received_byte); \endcode
 */

/**
 * \page serial_use_case_1 xȎgp - ر ް߹đM
 *
 * ̎gpʂłUSARTPʕȉ̗lɌ`Ԑݒ肳܂B:
 * - USARTD0gp
 * - ްڰ : 9600
 * -  : 8ޯ
 * - è : ֎~
 * - ~ޯ : 1
 * - RS232
 *
 * ̎gpʂUSARTʂĕ𑗂܂B
 *
 * \section serial_use_case_1_setup iK
 *
 * \subsection serial_use_case_1_setup_prereq OKv
 * -# \ref sysclk_group " ۯǗ(sysclk)"
 *
 * \subsection serial_use_case_1_setup_code ޗ
 * ȉ̌`ԐݒۼުĂɒǉȂȂ܂(ʓIconf_serial.ḩ
 * ɂłA剞p̧قɒǉ邱Ƃł܂)B
 * \code
 *    #define USART_SERIAL                     &USARTD0
 *    #define USART_SERIAL_BAUDRATE            9600
 *    #define USART_SERIAL_CHAR_LENGTH         USART_CHSIZE_8BIT_gc
 *    #define USART_SERIAL_PARITY              USART_PMODE_DISABLED_gc
 *    #define USART_SERIAL_STOP_BIT            false
 * \endcode
 *
 * pɒǉ:
 * \code
 *    sysclk_init();
 *
 *    static usart_serial_options_t usart_options = {
 *       .baudrate = USART_SERIAL_BAUDRATE,
 *       .charlength = USART_SERIAL_CHAR_LENGTH,
 *       .paritytype = USART_SERIAL_PARITY,
 *       .stopbits = USART_SERIAL_STOP_BIT
 *    };
 *
 *    usart_serial_init(USART_SERIAL, &usart_options);
 * \endcode
 *
 * \subsection serial_use_case_1_setup_flow Ƃ̗
 * -#  ۯ:
 *   - \code sysclk_init(); \endcode
 * -# USARTCӑI\̍쐬:
 *   - \code
 *        static usart_serial_options_t usart_options = {
 *           .baudrate = USART_SERIAL_BAUDRATE,
 *           .charlength = USART_SERIAL_CHAR_LENGTH,
 *           .paritytype = USART_SERIAL_PARITY,
 *           .stopbits = USART_SERIAL_STOP_BIT
 *        };
 *     \endcode
 * -# RS232ŏ:
 *   - \code usart_serial_init(USART_SERIAL_EXAMPLE, &usart_options); \endcode
 *
 * \section serial_use_case_1_usage giK
 *
 * \subsection serial_use_case_1_usage_code ޗ
 * Ⴆ΁ApÇق̎JԂɒǉ:
 * \code
 *       usart_serial_write_packet(USART_SERIAL, "Test String", strlen("Test String"));
 * \endcode
 *
 * \subsection serial_use_case_1_usage_flow Ƃ̗
 * -# USARTɕ:
 *   - \code usart_serial_write_packet(USART_SERIAL, "Test String", strlen("Test String")); \endcode
 */

#endif /* SERIAL_H_INCLUDED */
